program HADI;
{
HIPPO GAMES
(C) Pavel Krikava

Zdrojak a cely program je pod licenci GPL. viz. COPYING

Autor nezodpovida za pripadnou ujmu na zdravi zpusobenou prectenim zdrojaku.
}
uses crt, graph, dos;
type buf1 = array[1..32767] of word;

type hrac=record
          x,y,x1,y1: integer; {x,y:souradnice, v-pocitani vyher}
          z,v,vs,por: byte; {z:0-zivy,1-mrtvy,vs: index, por: poradi hrace}
          zx,zy : integer; { zmena x, zmena y}
          n, d, l, p: char; { jak daleko je do jednotlivych smeru }
          komp: boolean; {pocitac/clovek}
          end;

     polehracu = array [1..4] of hrac;
     polenapredefinovaniklaves = array [1..16] of char;

var
  gd, gm : integer; { grafika }
  pocet  : byte; { pocet hracu}
  start  : integer; { urcuje startovni x-ovou souradnici }
  pockat, {delay v kazdem cyklu}
  level, {jakej je level}
  rychlost, {rychlost hry}
  h: byte; {do kolika vyteztvi se hraje}
  pom, pom2, pixelcolor: integer;
  cheat: boolean; {cheat mod}
  ch     : char;  { cteni znaku z klavesnice pri hre }
  zvuk   : char;  { urcuje, zda je zapnuty zvuk }
  t      : file of char;      {soubor s ovladanim}
  error  : boolean; {pri nastavovani klaves kdyz jsou nejake stejne}
  ph     : polehracu; { hraci }
  pp     : polenapredefinovaniklaves; {pole zalozene pro snadnejsi}
  BUF    : ^buf1;     {buffer}        {porovnavani nadefinnovanych klaves}
  I,int,RES : word;
  int1   : pointer;   {stary casovac}
  f      : file;      {soubor se zmapou}
  ii, jj : integer;   {promena na cykly}
  var h1,m1,s1,t1,h2,m2,s2,t2:word; {mereni casu}

  label l; {na restart hry}


{--------------------- IntToStr--------------------------------}
{funkce prevadi integer na string}
function Inttostr (g:longint): string;
var s: string[11];
begin
  Str (g,s);
  inttostr:=s;
end;

{--------------------- INT_TIME---------------------------------}
{ obsluha interaptu }
procedure INT_TIME; interrupt;
begin
inc (int);
if int=res then int:=1;
if buf^[int] <> 0 then sound(buf^[int])
                   else nosound;
end;

{--------------------- NOVA HRA---------------------------------}
{ vypise Znovu? }
procedure nova_hra;
begin
  setcolor (15);
  SetTextStyle (Defaultfont, horizDir, 2);
  outtextXY (80,230,'Retry:ENTER,SPACE  Quit:ESC');
  SetTextStyle (Defaultfont, horizDir, 1);
end;

{-------------------- Nacti znak (redefine keys) -------------}
procedure nacti;
begin
ch:=readkey;
if ch=#0 then ch:=readkey;
end;

{-------------------- MERENI CASU -----------------------------}
procedure writetime (h1,m1,s1,t1,h2,m2,s2,t2: word);
var set1, set2: word;
begin
set1:=h1*3600+m1*60+s1;
set2:=h2*3600+m2*60+s2;
writeln ('Doba spusteni programu: '
,(set2-set1) div 60,' min ',(set2-set1) mod 60,' sek.');
end;

{--------------------- VYHRY ---------------------------------}
{ pocita a zobrazuje vyhry }
procedure pocitani_a_zobrazovani_vyher;
begin
  if ((ph[1].z=1) and (ph[2].z=1) and (ph[3].z=1) and (ph[4].z=1)) then
  nova_hra
  else
  if ((ph[2].z=1) and (ph[3].z=1) and (ph[4].z=1)) then
  begin {vyhra 1. hrace}
     ph[1].x:=1; ph[1].y:=1;
     setcolor (0);
     outtextXY (530,5,inttostr (ph[1].v));
     ph[1].v:=ph[1].v+1;
     setcolor (10);
     outtextXY (530,5,inttostr (ph[1].v));
     nova_hra;
   end
   else
  if (((ph[1].x=1) or (ph[1].y=1)) and ((ph[3].x=1) or (ph[3].y=1)) and ((ph[4].x=1) or (ph[4].y=1))) then
   begin {vyhra 2. hrace}
     ph[2].x:=1; ph[2].y:=1;
     setcolor (0);
     outtextxy (560,5,inttostr (ph[2].v));
     ph[2].v:=ph[2].v+1;
     setcolor (13);
     outtextxy (560,5,inttostr (ph[2].v));
     nova_hra;
   end
   else
  if (((ph[1].x=1) or (ph[1].y=1)) and ((ph[2].x=1) or (ph[2].y=1)) and ((ph[4].x=1) or (ph[4].y=1))) then
   begin {vyhra 3. hrace}
     ph[3].x:=1; ph[3].y:=1;
     setcolor (0);
     outtextxy (590,5,inttostr (ph[3].v));
     ph[3].v:=ph[3].v+1;
     setcolor (6);
     outtextxy (590,5,inttostr (ph[3].v));
     nova_hra;
   end
   else
  if (((ph[1].x=1) or (ph[1].y=1)) and ((ph[2].x=1) or (ph[2].y=1)) and ((ph[3].x=1) or (ph[3].y=1))) then
   begin {vyhra 4. hrace}
     ph[4].x:=1; ph[4].y:=1;
     setcolor (0);
     outtextxy (620,5,inttostr (ph[4].v));
     ph[4].v:=ph[4].v+1;
     setcolor (3);
     outtextxy (620,5,inttostr (ph[4].v));
     nova_hra;
   end;
end;

{--------------------- Pocitacem rizeny hrac --------------------}
procedure pocitac;
var n, d, l, p, m, x, y: integer;
begin
  randomize;
  m:= random (25); {kolik pixelu maximalne testovat}
  if (m>=0) and (m<15) then m:=20;
  n:=-1; d:=-1; l:=-1; p:=-1;
  ph[ii].x1:=ph[ii].x; ph[ii].y1:=ph[ii].y;
   repeat {zjistuje, jak daleko je nahoru}
     ph[ii].y1:=ph[ii].y1-1;
     inc (n);
     pixelcolor:= getpixel (ph[ii].x1,ph[ii].y1);
   until (pixelcolor<>0) or (n=m);
  ph[ii].x1:=ph[ii].x; ph[ii].y1:=ph[ii].y;
   repeat {zjistuje, jak daleko je dolu}
     ph[ii].y1:=ph[ii].y1+1;
     inc (d);
     pixelcolor:= getpixel (ph[ii].x1,ph[ii].y1);
   until (pixelcolor<>0) or (d=m);
  ph[ii].x1:=ph[ii].x; ph[ii].y1:=ph[ii].y;
   repeat {zjistuje, jak daleko ma doleva}
     ph[ii].x1:=ph[ii].x1-1;
     inc (l);
     pixelcolor:= getpixel (ph[ii].x1,ph[ii].y1);
   until (pixelcolor<>0) or (l=m);
  ph[ii].x1:=ph[ii].x; ph[ii].y1:=ph[ii].y;
   repeat {zjistuje, jak daleko ma doprava}
     ph[ii].x1:=ph[ii].x1+1;
     inc (p);
     pixelcolor:= getpixel (ph[ii].x1,ph[ii].y1);
   until (pixelcolor<>0) or (p=m);

  y:=random (50); {pravdepodobnost spusteni inteligence pro 2 stejne smery}
  if y=0 then
   begin
    {2 smery stejne}
    begin if (n=d) then x:=random (2); if x=0 then begin ph[ii].zx := 0; if ph[ii].zy <> 1 then ph[ii].zy := -1 end;
    if x=1 then begin ph[ii].zx := 0; if ph[ii].zy <> -1 then ph[ii].zy := 1; end; end;
    begin if (l=p) then x:=random (2); if x=0 then begin if ph[ii].zx <> 1 then ph[ii].zx := -1; ph[ii].zy := 0; end;
    if x=1 then begin if ph[ii].zx <> -1 then ph[ii].zx := 1; ph[ii].zy := 0; end; end;
    begin if (n=p) then x:=random (2); if x=0 then begin ph[ii].zx := 0; if ph[ii].zy <> 1 then ph[ii].zy := -1; end;
    if x=1 then begin if ph[ii].zx <> -1 then ph[ii].zx := 1; ph[ii].zy := 0; end; end;
    begin if (l=d) then x:=random (2); if x=0 then begin if ph[ii].zx <> 1 then ph[ii].zx := -1; ph[ii].zy := 0; end;
    if x=1 then begin ph[ii].zx := 0; if ph[ii].zy <> -1 then ph[ii].zy := 1; end; end;
    begin if (n=l) then x:=random (2); if x=0 then begin ph[ii].zx := 0; if ph[ii].zy <> 1 then ph[ii].zy := -1; end;
    if x=1 then begin if ph[ii].zx <> 1 then ph[ii].zx := -1; ph[ii].zy := 0; end; end;
    begin if (d=p) then x:=random (2); if x=0 then begin ph[ii].zx := 0; if ph[ii].zy <> 1 then ph[ii].zy := -1; end;
    if x=1 then begin if ph[ii].zx <> -1 then ph[ii].zx := 1; ph[ii].zy := 0; end; end;
   end;
  y:=random (50); {pravdepodobnost spusteni inteligence pro 3 stejne smery}
  if y=0 then {3  smery stejne}
   begin
    if (n=d) and (d=l) then begin x:=random (3);
    if x=0 then begin ph[ii].zx := 0; ph[ii].zy := -1; end;
    if x=1 then begin ph[ii].zx := 0; ph[ii].zy := 1; end;
    if x=2 then begin ph[ii].zx := -1; ph[ii].zy := 0; end;
    end;
    if (n=d) and (d=p) then begin x:=random (3);
    if x=0 then begin ph[ii].zx := 0; ph[ii].zy := -1; end;
    if x=1 then begin ph[ii].zx := 0; ph[ii].zy := 1; end;
    if x=2 then begin ph[ii].zx := 1; ph[ii].zy := 0; end;
    end;
    if (d=l) and (l=p) then begin x:=random (3);
    if x=0 then begin ph[ii].zx := 0; ph[ii].zy := 1; end;
    if x=1 then begin ph[ii].zx := -1; ph[ii].zy := 0; end;
    if x=2 then begin ph[ii].zx := 1; ph[ii].zy := 0; end;
    end;
    if (n=l) and (l=p) then begin x:=random (3);
    if x=0 then begin ph[ii].zx := 0; ph[ii].zy := -1; end;
    if x=1 then begin ph[ii].zx := -1; ph[ii].zy := 0; end;
    if x=2 then begin ph[ii].zx := 1; ph[ii].zy := 0; end;
    end;
   end;
  y:=random (2); {pravdepodobnost spusteni inteligence pro 1 stejny smer}
  if y=0 then
   begin
    {1 ze vsech vice}
    if (n>d) and (n>l) and (n>p) then begin ph[ii].zx := 0; ph[ii].zy := -1; end;
    if (d>n) and (d>l) and (d>p) then begin ph[ii].zx := 0; ph[ii].zy := 1; end;
    if (l>n) and (l>d) and (l>p) then begin ph[ii].zx := -1; ph[ii].zy := 0; end;
    if (p>n) and (p>d) and (p>l) then begin ph[ii].zx := 1; ph[ii].zy := 0; end;
   end;
  {odladuje bugy v inteligenci}
  for x:=0 to 2 do begin
    if (n=0) and (ph[ii].zx = 0) and (ph[ii].zy = -1) then begin ph[ii].zx := 0; ph[ii].zy := 1; end;
    if (d=0) and (ph[ii].zx = 0) and (ph[ii].zy = 1) then begin ph[ii].zx := -1; ph[ii].zy := 0; end;
    if (l=0) and (ph[ii].zx = -1) and (ph[ii].zy = 0) then begin ph[ii].zx := 1; ph[ii].zy := 0; end;
    if (p=0) and (ph[ii].zx = 1) and (ph[ii].zy = 0) then begin ph[ii].zx := 0; ph[ii].zy := -1; end;
   end;
end;

{------------------------ DELAY ---------------------------------}
{meni delay podle poctu zijicich cervu}
procedure rychlost_23;
begin
 if rychlost=1 then
   begin
     if (ph[1].z)+(ph[2].z)+(ph[3].z)+(ph[4].z)=1 then pockat:=12;{delay pri 3 hracich}
     if (ph[1].z)+(ph[2].z)+(ph[3].z)+(ph[4].z)=2 then pockat:=10;{delay pri 2 hracich}
   end;
   if rychlost=2 then
   begin
     if (ph[1].z)+(ph[2].z)+(ph[3].z)+(ph[4].z)=1 then pockat:=7;{delay pri 3 hracich}
     if (ph[1].z)+(ph[2].z)+(ph[3].z)+(ph[4].z)=2 then pockat:=5;{delay pri 2 hracich}
   end;
   if rychlost=3 then
   begin
     if (ph[1].z)+(ph[2].z)+(ph[3].z)+(ph[4].z)=1 then pockat:=2;{delay pri 3 hracich}
     if (ph[1].z)+(ph[2].z)+(ph[3].z)+(ph[4].z)=2 then pockat:=0;{delay pri 2 hracich}
   end;
end;

{-------------------------- VYSLEDKY ---------------------------------}
{Zobrazi zaverecnou tabulku}
procedure zobrazeni_vysledku;
begin
  for ii:=1 to 4 do ph[ii].vs:=ii;
  for ii:=1 to 3 do
  for jj:=1 to 3 do
  if ph[jj+1].v>ph[jj].v then
   begin
     pom:=ph[jj].v;
     pom2:=ph[jj].vs;
     ph[jj].v:=ph[jj+1].v;
     ph[jj].vs:=ph[jj+1].vs;
     ph[jj+1].v:=pom;
     ph[jj+1].vs:=pom2;
   end;
  SetTextStyle (0, horizDir, 1);
  for jj:=1 to 4 do ph[jj].por:=jj;
  if ph[1].v=ph[2].v then ph[2].por:=ph[1].por;{pri stejnem poctu bodu}
  if ph[2].v=ph[3].v then ph[3].por:=ph[2].por;{odladi poradi}
  if ph[3].v=ph[4].v then ph[4].por:=ph[3].por;
  cleardevice;               {vypis umisteni hracu a body}
  Setcolor (9);
  outtextXY (40,20,'FINAL SCORE');
  setcolor (4);
  outtextXY (40,460,'Press: SPACE, ENTER or ESC.');
  if ph[1].vs=1 then setcolor (10);
  if ph[1].vs=2 then setcolor (13);
  if ph[1].vs=3 then setcolor (6);
  if ph[1].vs=4 then setcolor (3);
  outtextXY (40,90,inttostr (ph[1].por));
  outtextXY (45,90,'. is player number');
  outtextXY (200,90,inttostr (ph[1].vs));
  outtextXY (220,90,'with');
  outtextXY (260,90,inttostr (ph[1].v));
  outtextXY (280,90,'wins.');
  if ph[ph[1].vs].komp=true then outtextXY (325,90,'(Computer)') else outtextXY (325,90,'(Human)');
  if ph[2].vs=1 then setcolor (10);
  if ph[2].vs=2 then setcolor (13);
  if ph[2].vs=3 then setcolor (6);
  if ph[2].vs=4 then setcolor (3);
  outtextXY (40,130,inttostr (ph[2].por));
  outtextXY (45,130,'. is player number ');
  outtextXY (200,130,inttostr (ph[2].vs));
  outtextXY (220,130,'with');
  outtextXY (260,130,inttostr (ph[2].v));
  outtextXY (280,130,'wins.');
  if ph[ph[2].vs].komp=true then outtextXY (325,130,'(Computer)') else outtextXY (325,130,'(Human)');
  if (pocet>2) then
   begin
     if ph[3].vs=1 then setcolor (10);
     if ph[3].vs=2 then setcolor (13);
     if ph[3].vs=3 then setcolor (6);
     if ph[3].vs=4 then setcolor (3);
     outtextXY (40,170,inttostr (ph[3].por));
     outtextXY (45,170,'. is player number');
     outtextXY (200,170,inttostr (ph[3].vs));
     outtextXY (220,170,'with');
     outtextXY (260,170,inttostr (ph[3].v));
     outtextXY (280,170,'wins.');
     if ph[ph[3].vs].komp=true then outtextXY (325,170,'(Computer)') else outtextXY (325,170,'(Human)');
   end;
  if (pocet>3) then
   begin
     if ph[4].vs=1 then setcolor (10);
     if ph[4].vs=2 then setcolor (13);
     if ph[4].vs=3 then setcolor (6);
     if ph[4].vs=4 then setcolor (3);
     outtextXY (40,210,inttostr (ph[4].por));
     outtextXY (45,210,'. is player number');
     outtextXY (200,210,inttostr (ph[4].vs));
     outtextXY (220,210,'with');
     outtextXY (260,210,inttostr (ph[4].v));
     outtextXY (280,210,'wins.');
     if ph[ph[4].vs].komp=true then outtextXY (325,210,'(Computer)') else outtextXY (325,210,'(Human)');
   end;
  ch:=#79;
  repeat
    ch:=readkey;
    if ch=#0 then ch:=readkey;
  until (ch=#32) or (ch=#27) or (ch=#13);
  SetTextStyle (Defaultfont, horizDir, 1);
  end;

{-------------------------- init -------------------------------}
{ inicializuje hru }
procedure init;
 begin
  assign (t,'hadi.cfg'); {nacte nastaveni klaves}
  reset (t);
  ii:=0;
  while eof(t)=false do begin
    inc (ii);
    read (t,ph[ii].n);
    read (t,ph[ii].d);
    read (t,ph[ii].l);
    read (t,ph[ii].p);
  end;
  close (t);
  cleardevice;
  repeat
   SetTextStyle (DefaultFont, HorizDir, 2); {uvodni obrazovka}
   SetColor (13);
   OutTextXY (230,10,'Hippo Games');
   SetTextStyle (DefaultFont, HorizDir, 1);
   setcolor (10);
   OutTextXY (290,30,'PRESENT');
   SetColor (12);
   SetTextStyle (DefaultFont, HorizDir, 2);
   OutTextXY (265,40,'H A D I');
   SetTextStyle (DefaultFont, HorizDir, 1);
   setcolor (10);
   OutTextXY (285,60,'FREEWARE');
   SetColor (15);
   OutTextXY (197,80,'(C) Pavel ''LinuX'' Krikava 1999');
   OutTextXY (229,90,'Prague, Czech Republic.');
   setcolor (9);
   OutTextXY (50,110,'SETTING');
   line (5,113,45,113);
   line (110,113,635,113);
   line (5,113,5,455);
   line (635,113,635,455);
   line (5,455,635,455);
   if keypressed then
   begin
   ch:=readkey;
     if ch=#0 then ch:=readkey;
     setcolor (0);
     SetTextStyle(4, 0, 1);
     case ch of
     #115: begin OutTextXY (60,120,(Zvuk)); if zvuk='Y' then zvuk:='N' else zvuk:='Y'; end;
     #112: begin OutTextXY (210,130,inttostr (Pocet)); inc (pocet); if pocet=5 then pocet:=2;
     OutTextXY (325,290,'');
     OutTextXY (325,300,'');
     OutTextXY (325,310,'');
     OutTextXY (325,318,'');
     end;
     #119: begin OutTextXY (320,140,inttostr (h)); inc (h); if h=51 then h:=1; end;
     #103: begin OutTextXY (225,150,inttostr (rychlost)); inc (rychlost); if rychlost=4 then rychlost:=1; end;
     #108: begin OutTextXY (60,160,inttostr (level)); inc (level); if level=5 then level:=1; end;
     #49: begin OutTextXY (15,300,''); if ph[1].komp=true then ph[1].komp:=false else ph[1].komp:=true; end;
     #50: begin OutTextXY (170,300,''); if ph[2].komp=true then ph[2].komp:=false else ph[2].komp:=true; end;
     #51: begin OutTextXY (325,300,''); if ph[3].komp=true then ph[3].komp:=false else ph[3].komp:=true; end;
     #52: begin OutTextXY (480,300,''); if ph[4].komp=true then ph[4].komp:=false else ph[4].komp:=true; end;
     #59: if cheat=false then cheat:=true else cheat:=false;
     #114: begin  {------------ predefinovavani klaves ------------------}
     cleardevice;
     setcolor (7);
     OutTextXY (5,10,'Press ESC if you don''t want to change the key.');
     setcolor (10);
     OutTextXY (5,30,'PLAYER 1');
     setcolor (7);
     OutTextXY (5,40,'Up:');    nacti; if ch<>#27 then ph[1].n:=ch; OutTextXY (60,40,ph[1].n);
     OutTextXY (5,50,'Down:');  nacti; if ch<>#27 then ph[1].d:=ch; OutTextXY (60,50,ph[1].d);
     OutTextXY (5,60,'Left:');  nacti; if ch<>#27 then ph[1].l:=ch; OutTextXY (60,60,ph[1].l);
     OutTextXY (5,70,'Right:'); nacti; if ch<>#27 then ph[1].p:=ch; OutTextXY (60,70,ph[1].p);
     setcolor (13);
     OutTextXY (5,90,'PLAYER 2');
     setcolor (7);
     OutTextXY (5,100,'Up:');    nacti; if ch<>#27 then ph[2].n:=ch; OutTextXY (60,100,ph[2].n);
     OutTextXY (5,110,'Down:');  nacti; if ch<>#27 then ph[2].d:=ch; OutTextXY (60,110,ph[2].d);
     OutTextXY (5,120,'Left:');  nacti; if ch<>#27 then ph[2].l:=ch; OutTextXY (60,120,ph[2].l);
     OutTextXY (5,130,'Right:'); nacti; if ch<>#27 then ph[2].p:=ch; OutTextXY (60,130,ph[2].p);
     setcolor (6);
     OutTextXY (5,150,'PLAYER 3');
     setcolor (7);
     OutTextXY (5,160,'Up:');    nacti; if ch<>#27 then ph[3].n:=ch; OutTextXY (60,160,ph[3].n);
     OutTextXY (5,170,'Down:');  nacti; if ch<>#27 then ph[3].d:=ch; OutTextXY (60,170,ph[3].d);
     OutTextXY (5,180,'Left:');  nacti; if ch<>#27 then ph[3].l:=ch; OutTextXY (60,180,ph[3].l);
     OutTextXY (5,190,'Right:'); nacti; if ch<>#27 then ph[3].p:=ch; OutTextXY (60,190,ph[3].p);
     setcolor (3);
     OutTextXY (5,210,'PLAYER 4');
     setcolor (7);
     OutTextXY (5,220,'Up:');    nacti; if ch<>#27 then ph[4].n:=ch; OutTextXY (60,220,ph[4].n);
     OutTextXY (5,230,'Down:');  nacti; if ch<>#27 then ph[4].d:=ch; OutTextXY (60,230,ph[4].d);
     OutTextXY (5,240,'Left:');  nacti; if ch<>#27 then ph[4].l:=ch; OutTextXY (60,240,ph[4].l);
     OutTextXY (5,250,'Right:'); nacti; if ch<>#27 then ph[4].p:=ch; OutTextXY (60,250,ph[4].p);
     {--- Zjistuje jestli nejsou nejake klavesy stejne nastavene ---}
     error:=false;
     for ii:=1 to 4 do pp[ii]:=ph[ii].n;
     for ii:=5 to 8 do pp[ii]:=ph[ii-4].d;
     for ii:=9 to 12 do pp[ii]:=ph[ii-8].l;
     for ii:=13 to 16 do pp[ii]:=ph[ii-12].p;
     for jj:=1 to 15 do begin
       pom:=0;
       for ii:=1 to 16 do
       if pp[jj]=pp[ii] then begin
         inc (pom);
         if pom>1 then error:=true;
       end;
     end;
     if error=true then begin
       setcolor (12);
       OutTextXY (5,280,'Warning: Some of the keys are the same !!! Press any key...');
      end
     else begin
       setcolor (10);
       OutTextXY (5,280,'All right. Press any key...');
      end;
     ReadKey;
     ClearDevice;
     end;
     #100: begin ph[1].n:=#72;ph[1].d:=#80;ph[1].l:=#75;ph[1].p:=#77;
                 ph[2].n:=#56;ph[2].d:=#53;ph[2].l:=#52;ph[2].p:=#54;
                 ph[3].n:=#100;ph[3].d:=#120;ph[3].l:=#122;ph[3].p:=#99;
                 ph[4].n:=#106;ph[4].d:=#110;ph[4].l:=#98;ph[4].p:=#109;
                 OutTextXY (15,315,'')
                 end;
     end;
     end;
     SetColor (2);
     OutTextXY (10,120,'S');
     OuttextXY (92,130,'p');
     OuttextXY (92,140,'w');
     OuttextXY (10,150,'G');
     OutTextXY (10,160,'L');
     SetColor (7);
     OutTextXY (17,120,'ound: ');
     OutTextXY (60,120,(Zvuk));
     OuttextXY (10,130,'Number of  layers (2-4):');
     OutTextXY (210,130,inttostr (Pocet));
     OuttextXY (10,140,'Number of  ins to end the game (1-50):');
     OutTextXY (320,140,inttostr (h));
     OuttextXY (10,150,' ame speed (1-3,3=faster):');
     OutTextXY (225,150,inttostr (rychlost));
     OutTextXY (10,170,'1 - Clear screen.');
     OutTextXY (10,180,'2 - Screen is divided into two parts.');
     OutTextXY (10,190,'3 - Randomly located signs Linux.');
     OutTextXY (10,200,'4 - Randomly located dots.');
     OutTextXY (10,160,' evel: ');
     OutTextXY (60,160,inttostr (level));

   SetColor (9);
   OutTextXY (50,220,'PLAYERS');
   line (10,223,45,223);
   line (110,223,630,223);
   line (10,223,10,450);
   line (630,223,630,450);
   line (10,450,630,450);
   SetColor (9);
   OutTextXY (50,335,'COMPUTER IQ SETTINGS');
   line (15,338,45,338);
   line (215,338,625,338);
   line (15,338,15,445);
   line (625,338,625,445);
   line (15,445,625,445);
   SetColor (12);
   OutTextXY (200,385,'!!!  UNDER CONSTRUCTION  !!!');
   SetColor (2);
   OutTextXY (15,260,'R');
   OutTextXY (15,270,'D');
   SetColor (7);
   OutTextXY (15,260,' edefine keys.');
   OutTextXY (15,270,' efault keys.');
   OutTextXY (15,250,'Keys are in the order ,,,.');
   OutTextXY (15,240,'H, P, K, M for player one means ,,,.');
   OutTextXY (15,230,'To choose the Human/Computer press the number of the player.');
   setcolor (10);
   OutTextXY (15,290,'PLAYER 1');
   Setcolor (7);
   if ph [1].komp=true then OutTextXY (15,300,'Computer') else OutTextXY (15,300,'Human');
   if ph[1].komp=false then begin
   OutTextXY (15,315,'Keys:');
   OutTextXY (60,315,ph[1].n+ph[1].d+ph[1].l+ph[1].p);
   end
   else begin
     Setcolor (0);
     OutTextXY (15,315,'');
   end;
   setcolor (13);
   OutTextXY (170,290,'PLAYER 2');
   Setcolor (7);
   if ph [2].komp=true then OutTextXY (170,300,'Computer') else OutTextXY (170,300,'Human');
   if ph[2].komp=false then begin
   OutTextXY (170,315,'Keys:');
   OutTextXY (215,315,ph[2].n+ph[2].d+ph[2].l+ph[2].p);
   end
   else begin
     Setcolor (0);
     OutTextXY (170,315,'');
   end;
   if pocet>2 then begin
     setcolor (6);
     OutTextXY (325,290,'PLAYER 3');
     Setcolor (7);
     if ph [3].komp=true then OutTextXY (325,300,'Computer') else OutTextXY (325,300,'Human');
     if ph[3].komp=false then begin
     OutTextXY (325,315,'Keys:');
     OutTextXY (370,315,ph[3].n+ph[3].d+ph[3].l+ph[3].p);
     end
   else begin
     Setcolor (0);
     OutTextXY (325,315,'');
   end;
   end;
   if pocet=4 then begin
     setcolor (3);
     OutTextXY (480,290,'PLAYER 4');
     Setcolor (7);
     if ph [4].komp=true then OutTextXY (480,300,'Computer') else OutTextXY (480,300,'Human');
     if ph[4].komp=false then begin
     OutTextXY (480,315,'Keys:');
     OutTextXY (525,315,ph[4].n+ph[4].d+ph[4].l+ph[4].p);
     end
   else begin
     Setcolor (0);
     OutTextXY (480,315,'');
   end;
   end;
     SetColor (4);
     OutTextXY (5,460,'Start: ENTER, SPACE                                                   Quit: ESC');
  until (ch=#13) or (ch=#32) or (ch=#27);

  if zvuk='Y' then begin
     getintvec ($1c, int1);
     getmem(buf,sizeof(buf^));
     assign(f,'hadi.zsn');
     reset(f,1);
     blockread(f,RES,2);         {kolik polozek se bude cist ?}
     blockread(f,buf^,RES*2,I);  {nacteni bufferu buf, RES*2 - buffer je array of }
     close(f);                   {word, word= dva byte}
     setintvec ($1c, addr (int_time));
  end;
  assign (t,'hadi.cfg'); {zapise nastaveni klaves}
  rewrite (t);
  for ii:=1 to 4 do begin
      write (t,ph[ii].n);
      write (t,ph[ii].d);
      write (t,ph[ii].l);
      write (t,ph[ii].p);
    end;
  close (t);
 end;

{------------------------------ done ---------------------------}
procedure done;
begin
  if zvuk='Y' then begin
     setintvec ($1c, int1);
     nosound;
     freemem(buf,sizeof(buf^));
    end;
  closegraph;
  clrscr;
  GetTime (h2,m2,s2,t2);
  WriteTime (h1,m1,s1,t1,h2,m2,s2,t2);
  writeln ('HADI (C) Pavel Krikava, Hippo games 1999.');
  readkey;
end;

{----------------------------- Zpracuj_znak ---------------------}
{ obsluhuje stisk klavesy pri hre }
function Zpracuj_znak : boolean;
begin
  ch:=readkey;
  if ch=#0 then ch:=readkey;
  zpracuj_znak := true;
  if (ch=#32) or (ch=#13) then zpracuj_znak := false;
  for ii:=1 to 4 do { zpracovava klavesy opravdovych hracu }
    if ph[ii].komp=false then begin
       if ch=ph[ii].n then  begin
                ph[ii].zx := 0;
                if ph[ii].zy <> 1 then ph[ii].zy := -1;
               end;
       if ch=ph[ii].d then begin
                ph[ii].zx := 0;
                if ph[ii].zy <> -1 then ph[ii].zy := 1;
               end;
       if ch=ph[ii].l then begin
                if ph[ii].zx <> 1 then ph[ii].zx := -1;
                ph[ii].zy := 0;
               end;
       if ch=ph[ii].p then begin
                if ph[ii].zx <> -1 then ph[ii].zx := 1;
                ph[ii].zy := 0;
               end;
    end;
end;

{---------------------------- begin -----------------------------}

begin
GetTime (h1,m1,s1,t1);
clrscr;
gd := detect;
initgraph(gd,gm,'');
if graphresult <> grok then begin
   writeln('Nepodarilo se zavest grafiku! Zkontrolujte, zda je u hry soubor EGAVGA.BGI.');
   halt(1);
end;
zvuk:='N'; pocet:=2; level:=1; h:=5; rychlost:=2;
repeat
  for ii:=1 to 4 do
  ph[ii].v:=0;
  ch:=#100;
  init;
  if ch=#27 then break;
  l:
  int:=0;
{pri restartu hry nastavuje hodnoty na zakladni}
  if rychlost=1 then pockat:=15; {zakladni delay pri vsech 4 hracich zivych}
  if rychlost=2 then pockat:=10;
  if rychlost=3 then pockat:=5;
  ch:=#55;
  start:=round (640/(pocet+1));
  for ii := 1 to 4 do begin
     ph[ii].zx:=0;
     ph[ii].zy:=-1;
     ph[ii].z:=0;
     ph[ii].x:=ii*start;
     ph[ii].y:=400;
  end;

  cleardevice;
  if level=2 then    {vykresluje plochu pro jednotlive levely}
  begin
   setcolor (4);
   line (1,200,200,200);
   line (220,200,420,200);
   line (440,200,639,200);
  end;
  if level=3 then
   begin
     randomize;
     setcolor (12);
     SetTextStyle (defaultfont, HorizDir, 2);
     for i:=1 to 6 do
      begin
        ii:=random (200);
        if ii<20 then ii:=20;
        outtextxy (random (550),ii,'Linux');
      end;
   end;
  if level=4 then
   begin
     for i:=1 to 60 do
      begin
        ii:=random (480);
        if ii<20 then ii:=20;
        putpixel (random (640),ii,15);
      end;
   end;
  SetLineStyle (SolidLn, 0, ThickWidth);
  SetColor (4);
   line (1,1,640,1);     {Vykresli na monitor zakladni plochu}
   line (1,1,1,480);
   line (638,478,638,1);
   line (638,478,1,478);  {az sem ohraniceni}
   line (1,15,639,15);
   line (470,1,470,15); {pred rekordem}
   SetTextStyle (DefaultFont, HorizDir, 1);
   setcolor (9);               {zobrazeni vyher a pixelu}
   outtextxy (480,5,'WINS');
   setcolor (10);
   outtextXY (530,5,inttostr (ph[1].v));
   setcolor (13);
   outtextxy (560,5,inttostr (ph[2].v));
   setcolor (6);
   outtextxy (590,5,inttostr (ph[3].v));
   setcolor (3);
   outtextxy (620,5,inttostr (ph[4].v));
   setcolor (9);
   SetTextStyle (Defaultfont, horizDir, 1);
   OutTextXY (5,5,'HADI v1,4 BETA (C) Pavel ''Linux'' Krikava, Hippo games 1999');

 repeat
  SetLineStyle (SolidLn, 0, NormWidth);
  SetColor (0);

  if keypressed then if Zpracuj_znak = false then goto l;
  ii:=1; if (ph[ii].komp=true) and (ph[ii].z=0) then pocitac;
  ii:=2; if (ph[ii].komp=true) and (ph[ii].z=0) then pocitac;
  ii:=3; if (ph[ii].komp=true) and (ph[ii].z=0) then pocitac;
  ii:=4; if (ph[ii].komp=true) and (ph[ii].z=0) then pocitac;
  if cheat=false then
  for ii:=1 to 4 do
   begin
     pixelcolor:= getpixel (ph[ii].x,ph[ii].y); {zjistuje barvu pixelu}
     if pixelcolor <> 0 then      {kdyz je jina, nez cerna, tak hodi cerva na}
      begin                       {1,1, kde taky neni cerna, tak se to furt}
        ph[ii].x:=1;              {opakuje}
        ph[ii].y:=1;
      end;
     end
     else {cheat mod}
     for ii:=1 to 4 do
      begin
        pixelcolor:= getpixel (ph[ii].x,ph[ii].y);
        if (pixelcolor <> 0) and (pixelcolor <> 10) and (pixelcolor <> 13) and (pixelcolor <> 6) and (pixelcolor <> 3) then
         begin
           ph[ii].x:=1;
           ph[ii].y:=1;
         end;
      end;

  if pocet=2 then {nici prebytecne cervi}
   begin
     ph[3].x:=1; ph[3].y:=1;
     ph[4].x:=1; ph[4].y:=1;
   end;
  if pocet=3 then begin ph[4].x:=1; ph[4].y:=1; end;
  for ii:=1 to 4 do
   if (ph[ii].x=1) or (ph[ii].y=1) then ph[ii].z:=1;{prirazuje z jestli je mrtvej}
  putpixel (ph[1].x,ph[1].y,10); {vykresluje cervi}
  putpixel (ph[2].x,ph[2].y,13);
  putpixel (ph[3].x,ph[3].y,6);
  putpixel (ph[4].x,ph[4].y,3);

  for ii := 1 to 4 do begin {pohybuje cervi}
     ph[ii].x :=ph[ii].x+ph[ii].zx;
     ph[ii].y :=ph[ii].y+ph[ii].zy;
   end;

  rychlost_23; {prirazuje delay podle mrtvych cervu}

  pocitani_a_zobrazovani_vyher;

  if (ph[1].v=h) or (ph[2].v=h) or (ph[3].v=h) or (ph[4].v=h) then {prerusi hru pri urcitem poctu bodu}
  zobrazeni_vysledku;

  Delay (pockat);
until (ch=#32) or (ch=#27) or (ch=#13);
if ch=#27 then ch:=#32;
if zvuk='Y' then begin
     setintvec ($1c, int1);
     nosound;
     freemem(buf,sizeof(buf^));
  end;
until ch=#27;
done;
end.
